
#ifndef SCNSL__MY_TASK_SENDER_HH
#define SCNSL__MY_TASK_SENDER_HH



/// @file
/// Source node.


#include <systemc>
#include <tlm.h>

// Allowing Scnsl::Rtl::LinkNode_t usage:
//#define SCNSL__TLM__USE_LINK_NODE_HH

// Including the library:
#include <scnsl.hh>



class MyTaskSender :
    public Scnsl::Tlm::TlmTask_if_t
{

public:

    SC_HAS_PROCESS( MyTaskSender );

    /// @brief Constructor.
    ///
    /// @param name This module name.
    /// @param id this module unique ID.
    /// @param n The node on which this task is placed.
    /// @param proxies The number of connected task proxies.
    /// @throw std::invalid_argument If proxies is zero.
    ///
	MyTaskSender( sc_core::sc_module_name name,
                  const task_id_t id,
                  Scnsl::Core::Node_t * n,
                  const size_t proxies )
    	throw ( std::invalid_argument );

    virtual ~MyTaskSender() throw ();

	virtual void b_transport( tlm::tlm_generic_payload & p, sc_core::sc_time & t );

protected:

    /// @name Processes.
    //@{

    void writingProcess();

    //@}

private:

    MyTaskSender( MyTaskSender & );

    MyTaskSender & operator = ( MyTaskSender & );

};

#endif

